import bb.cascades 1.0
import bb.system 1.0
Page {
    id: aboutPage
    signal back()
    titleBar: TitleBar {
        visibility: ChromeVisibility.Overlay
        title: "About"
        dismissAction: ActionItem {
            title: "Back"
            onTriggered: {
                aboutPage.back();
            }
        }
    }
    actionBarVisibility: ChromeVisibility.Visible
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.Disabled
    actions: [
        InvokeActionItem {
            ActionBar.placement: ActionBarPlacement.OnBar
            title: "Share"
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.SHARE"
                data: "Check out Reddit in Motion, a great reddit app! Get it free on BlackBerry World - http://bit.ly/ZosKTV"
            }

        },
        InvokeActionItem {
            imageSource: "asset:///images/twitter.png"
            ActionBar.placement: ActionBarPlacement.OnBar
            title: "Follow Us"
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.OPEN"
                uri: "http://bit.ly/14h8Yxm"
            }
        },
        ActionItem {
            imageSource: "asset:///images/ic_info.png"
            ActionBar.placement: ActionBarPlacement.OnBar
            title: "Thanks!"
            onTriggered: {
                thanksDialog.show();
            }
            attachedObjects: [
                SystemDialog {
                    id: thanksDialog
                    title: "Thanks!"
                    body: "Thank you for downloading Reddit in Motion! If you enjoy using the app, please consider leaving us a rating on BlackBerry World. Also, we would love to hear any feedback or feature requests that you have! You can contact us at domisydev@gmail.com."
                }
            ]
        }
    ]
    //ScrollView {
    Container {
        layout: DockLayout {
        }
        ImageView {
            imageSource: "asset:///images/aboutImage.png"
            scalingMethod: ScalingMethod.Fill

        }
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: 100
            leftPadding: 600
            layout: StackLayout {
            }
            Label {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                id: versionLabel
                textStyle.fontSize: FontSize.Large
                textStyle.color: Color.Black
                //text: "v0.1.0.0"
                text: "v" + app.getVersion()
            }
            Label {
                multiline: true
                content.flags: TextContentFlag.ActiveText
                textStyle.textAlign: TextAlign.Center
                verticalAlignment: VerticalAlignment.Center
                textStyle.color: Color.Black
                textStyle.fontStyle: FontStyle.Italic
                text: "©2013 Domisy Dev\n Developer - Theodore Mavrakis\nDesigner - Aslan Vatsaev @avatsaev\nChannel - C000DD3B9"
            }
        }
    }
}
