import bb.cascades 1.0

Container {

    id: accountBar
    signal scrolling(bool scrolling)
    property string selectedTab: "comments"
    property string theme: "dark"

    property string username: "Username"
    property string comKarma: "0"
    property string linkKarma: "0"

    property variant selectedLabelColor: Color.create("#242424")
    property variant unselectedLabelColor: Color.create("#187cc8")
    property variant lightGrey: Color.create("#c0c0c0")

    visible: true

    horizontalAlignment: HorizontalAlignment.Fill

    verticalAlignment: VerticalAlignment.Top
    preferredWidth: Infinity

    layout: StackLayout {

    }

    Container {
        preferredHeight: 130
        id: baseContainer
        gestureHandlers: [

            TapHandler {

                onTapped: {
                    toggleExpanded()
                }
            }
        ]

        horizontalAlignment: HorizontalAlignment.Fill

        layout: DockLayout {
        }
        background: Color.create("#252525")
        Container {
            layout: StackLayout {
                orientation: LayoutOrientation.LeftToRight
            }
            Container {
                id: _username
                //maxWidth: //450
                verticalAlignment: VerticalAlignment.Center
                horizontalAlignment: HorizontalAlignment.Left
                leftPadding: 10
                /* layout: DockLayout {
                 * 
                 }*/
                layoutProperties: StackLayoutProperties {
                    spaceQuota: 1
                }
                Label {
                    id: labelUsername
                    text: ifUsernameSaved()
                    verticalAlignment: VerticalAlignment.Center
                    textStyle.color: lightGrey
                    textStyle.fontSize: FontSize.XLarge
                    textStyle.fontWeight: FontWeight.Normal
                    textFormat: TextFormat.Plain
                    //autoSize.maxLineCount: 2
                    multiline: false
                    textStyle.lineHeight: 0.7
                    textStyle.textAlign: TextAlign.Center
                    function ifUsernameSaved() {
                        var user = app.getSavedUsername()
                        if (user == "") {
                            return accountBar.username;
                        } else return user;
                    }
                }

            }

            Container {
                id: _userDataA
                horizontalAlignment: HorizontalAlignment.Right
                layout: StackLayout {
                    orientation: LayoutOrientation.LeftToRight
                }
                bottomPadding: 5.0
                topPadding: 5.0
                rightPadding: 5.0
                leftPadding: 5.0
                Container {
                    id: _commentK
                    layout: StackLayout {
                    }
                    leftPadding: 30.0
                    rightPadding: 30.0
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        topPadding: 15
                        ImageView {
                            imageSource: "images/commentsIconTitlebar.png"
                            verticalAlignment: VerticalAlignment.Center
                            horizontalAlignment: HorizontalAlignment.Center
                            scalingMethod: ScalingMethod.AspectFit
                            minHeight: 60
                        }
                    }
                    Label {
                        text: accountBar.comKarma
                        textStyle.color: Color.create("#c2c2c2")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Center
                        textStyle.fontSize: FontSize.Small
                    }
                }
                Container {
                    id: _linkK
                    layout: StackLayout {
                    }
                    leftPadding: 30.0
                    rightPadding: 30.0
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        topPadding: 15
                        ImageView {
                            imageSource: "images/linkIconTitlebar.png"
                            verticalAlignment: VerticalAlignment.Center
                            horizontalAlignment: HorizontalAlignment.Center
                            scalingMethod: ScalingMethod.AspectFit
                            minHeight: 60
                        }
                    }
                    Label {
                        text: accountBar.linkKarma
                        textStyle.color: Color.create("#c2c2c2")
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        textStyle.fontSize: FontSize.Small
                    }
                }
            }
        }
        /*Divider {
         * id: divider
         * visible: false
         * verticalAlignment: VerticalAlignment.Bottom
         * horizontalAlignment: HorizontalAlignment.Fill
         }*/
        Container {
            id: divider
            visible: true
            topMargin: 0
            topPadding: 0
            bottomMargin: 0
            bottomPadding: 0
            preferredWidth: Infinity
            preferredHeight: 1
            background: Color.DarkGray
            verticalAlignment: VerticalAlignment.Bottom
        }
    }

    //-----------------------------------------------
    //--||--//
    //-----------------------------------------------

    Container {
        id: accountBarExpanded

        visible: true

        layout: DockLayout {
        }
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Bottom
        bottomPadding: 5.0
        background: Color.create("#252525")
        topPadding: 10.0
        ScrollView {
            horizontalAlignment: HorizontalAlignment.Fill
            onTouch: {
                if (event.touchType == TouchType.Move) {
                    //mediaView.parent.peekEnabled = false;
                    scrolling(true);
                } else if (event.touchType == TouchType.Up) {
                    //mediaView.parent.peekEnabled = true;
                    scrolling(false);
                } else {
                    //mediaView.parent.peekEnabled = true;
                    scrolling(false);
                }
            }
            scrollViewProperties.scrollMode: ScrollMode.Horizontal
            content: Container {
                //background: Color.Red
                id: _userDataB
                verticalAlignment: VerticalAlignment.Center
                horizontalAlignment: HorizontalAlignment.Fill
                //preferredWidth: maxWidth
                layout: StackLayout {
                    orientation: LayoutOrientation.LeftToRight

                }

                animations: [
                    ParallelAnimation {
                        id: revealExpandedControls

                        animations: [
                            TranslateTransition {

                                fromY: -80
                                toY: 0
                                duration: 200

                            },
                            FadeTransition {
                                fromOpacity: 0
                                toOpacity: 1
                                duration: 200

                            }
                        ]
                    }
                ]

                bottomPadding: 5.0
                topPadding: 5.0
                rightPadding: 5.0
                leftPadding: 5.0

                Container {
                    id: _comments
                    background: lightGrey
                    property bool selected: true

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: commentsLabel
                        text: "COMMENTS"
                        textStyle.color: selectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }
                    gestureHandlers: [

                        TapHandler {

                            onTapped: {
                                _comments.selected = true
                                toggleExpanded();
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _comments.background = lightGrey
                            commentsLabel.textStyle.setColor(selectedLabelColor);
                            _posts.selected = false
                            _saved.selected = false
                            _liked.selected = false
                            _hidden.selected = false
                            _disliked.selected = false
                            selectedTab = "comments"
                        } else {
                            _comments.background = Color.Transparent
                            commentsLabel.textStyle.setColor(unselectedLabelColor);
                        }
                    }

                }
                Container {

                    id: _posts

                    property bool selected: false

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: postsLabel
                        text: "POSTS"
                        textStyle.color: unselectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }

                    gestureHandlers: [

                        TapHandler {

                            onTapped: {
                                _posts.selected = true
                                toggleExpanded()
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _posts.background = lightGrey
                            postsLabel.textStyle.setColor(selectedLabelColor);
                            _comments.selected = false
                            _saved.selected = false
                            _liked.selected = false
                            _hidden.selected = false
                            _disliked.selected = false
                            selectedTab = "submitted"
                        } else {
                            _posts.background = Color.Transparent
                            postsLabel.textStyle.setColor(unselectedLabelColor);

                        }
                    }

                }

                Container {

                    id: _liked

                    property bool selected: false

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: likedLabel
                        text: "LIKED"
                        textStyle.color: unselectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }

                    gestureHandlers: [

                        TapHandler {

                            onTapped: {
                                _liked.selected = true
                                toggleExpanded();
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _liked.background = lightGrey
                            likedLabel.textStyle.setColor(selectedLabelColor);
                            _posts.selected = false
                            _saved.selected = false
                            _comments.selected = false
                            _hidden.selected = false
                            _disliked.selected = false
                            selectedTab = "liked"
                        } else {
                            _liked.background = Color.Transparent
                            likedLabel.textStyle.setColor(unselectedLabelColor);
                        }
                    }

                }

                Container {

                    id: _disliked

                    property bool selected: false

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: dislikedLabel
                        text: "DISLIKED"
                        textStyle.color: unselectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }

                    gestureHandlers: [

                        TapHandler {

                            onTapped: {
                                _disliked.selected = true
                                toggleExpanded();
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _disliked.background = lightGrey
                            dislikedLabel.textStyle.setColor(selectedLabelColor);
                            _posts.selected = false
                            _saved.selected = false
                            _comments.selected = false
                            _hidden.selected = false
                            _liked.selected = false
                            selectedTab = "disliked"
                        } else {
                            _disliked.background = Color.Transparent
                            dislikedLabel.textStyle.setColor(unselectedLabelColor);
                        }
                    }

                }

                Container {

                    id: _hidden

                    property bool selected: false

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: hiddenLabel
                        text: "HIDDEN"
                        textStyle.color: unselectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }

                    gestureHandlers: [

                        TapHandler {
                            onTapped: {
                                _hidden.selected = true
                                toggleExpanded();
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _hidden.background = lightGrey
                            hiddenLabel.textStyle.setColor(selectedLabelColor);
                            _posts.selected = false
                            _saved.selected = false
                            _comments.selected = false
                            _liked.selected = false
                            _disliked.selected = false
                            selectedTab = "hidden"
                        } else {
                            _hidden.background = Color.Transparent
                            hiddenLabel.textStyle.setColor(unselectedLabelColor);
                        }
                    }

                }

                Container {

                    id: _saved

                    property bool selected: false

                    layout: StackLayout {

                    }
                    leftPadding: 22
                    rightPadding: 22

                    Label {
                        id: savedLabel
                        text: "SAVED"
                        textStyle.color: unselectedLabelColor
                        horizontalAlignment: HorizontalAlignment.Center

                        textStyle.fontSize: FontSize.Small
                        verticalAlignment: VerticalAlignment.Bottom

                    }

                    gestureHandlers: [

                        TapHandler {

                            onTapped: {
                                _saved.selected = true
                                toggleExpanded();
                            }
                        }
                    ]

                    onSelectedChanged: {
                        if (selected) {
                            _saved.background = lightGrey
                            savedLabel.textStyle.setColor(selectedLabelColor);
                            _posts.selected = false
                            _comments.selected = false
                            _liked.selected = false
                            _hidden.selected = false
                            _disliked.selected = false
                            selectedTab = "saved"
                        } else {
                            _saved.background = Color.Transparent
                            savedLabel.textStyle.setColor(unselectedLabelColor);
                        }
                    }

                }

            }
        }

    }

    function toggleExpanded() {

        if (accountBarExpanded.visible) {
            //accountBar.maxHeight = 130
            divider.visible = false
            accountBarExpanded.visible = false

        } else {
            //accountBar.maxHeight = 290
            divider.visible = true
            accountBarExpanded.visible = true
            revealExpandedControls.play()

        }

    }

}
