import bb.cascades 1.0
import org.labsquare 1.0

Container {

    function themeStyleToString(style) {

        switch (style) {
            case VisualStyle.Bright:
                return "bright"
            case VisualStyle.Dark:
                return "dark"
        }
        return "dark"
    }

    onCreationCompleted: {
        if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
            background = Color.create("#D2D2D2")

        } else {
            background = Color.create("#ff202020")
        }

    }

    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill

    layout: DockLayout {
    }

    Container {
        layout: StackLayout {
        }

        //background: Color.create("#ffd55b00")
        background: getContainerColor()
        function getContainerColor() {
            if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
                return Color.create("#2E2E2E");
            } else {
                return Color.create("#C6C6C6");
            }
        }
        Container {
            layout: DockLayout {

            }
            preferredHeight: 62
            minHeight: 62
            preferredWidth: Infinity
            verticalAlignment: VerticalAlignment.Top

            Container {
                topPadding: 0
                leftPadding: 5
                layout: StackLayout {
                    orientation: LayoutOrientation.LeftToRight
                }
                Container {
                    topPadding: 3
                    ImageView {
                        imageSource: "asset:///images/iconx114.png"
                        preferredHeight: 56
                        preferredWidth: 56
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Center
                    }
                }
                Label {
                    verticalAlignment: VerticalAlignment.Center
                    text: "Frontpage"
                    textStyle.fontSize: FontSize.PointValue
                    textStyle.fontSizeValue: 8
                    //textStyle.color: Color.create("#ffebebeb")
                    textStyle.color: getTextColor()
                    function getTextColor() {
                        if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
                            return Color.create("#D2D2D2");
                        } else {
                            return Color.create("#2E2E2E");
                        }
                    }
                }
            }
        }
    }
    Container {
        layout: StackLayout {

        }
        Container {
            id: top_

            horizontalAlignment: HorizontalAlignment.Fill

            verticalAlignment: VerticalAlignment.Top
            layout: DockLayout {

            }
            leftPadding: 15
            rightPadding: 15
            topPadding: 60

            //background: Color.create("#ff81ffb9")
            Container {
                topPadding: 5
                bottomPadding: 5
                layout: DockLayout {

                }
                Container {
                    rightPadding: 4
                    //bottomPadding: 6
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Label {
                        text: "No Image"
                        textStyle.textAlign: TextAlign.Center
                        textStyle.fontSize: FontSize.Small
                        textStyle.fontWeight: FontWeight.W100
                        horizontalAlignment: HorizontalAlignment.Center
                        //textStyle.color: Color.create("#ffffffff")
                        onCreationCompleted: {
                            if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
                                textStyle.color = Color.DarkGray

                            } else {
                                textStyle.color = Color.DarkGray
                            }
                        }
                    }
                }
                WebImageView {
                    preferredHeight: 175
                    preferredWidth: 175
                    maxHeight: 175
                    maxWidth: 175
                    objectName: "thumbnailImage"
                    //imageSource: "asset:///images/gold-insignia-big.png"
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment: VerticalAlignment.Center
                    scalingMethod: ScalingMethod.AspectFit

                }
            }

            Container {
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                layout: StackLayout {
                    orientation: LayoutOrientation.TopToBottom
                }
                Label {
                    objectName: "scoreLabel"
                    text: "0"
                    textStyle.color: Color.create("#ffd55b00")
                    textStyle.textAlign: TextAlign.Center
                    textStyle.fontSize: FontSize.Medium
                    textStyle.fontWeight: FontWeight.W500
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Top
                }
                Container {
                    layout: DockLayout {

                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    ImageView {
                        imageSource: "asset:///images/commentBubble.png"

                    }
                    Container {
                        //background: Color.Red
                        topPadding: 0
                        rightPadding: 4
                        bottomPadding:0
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Top
                        Label {
                            objectName: "commentCountLabel"
                            text: "0"
                            textStyle.textAlign: TextAlign.Center
                            textStyle.fontSize: FontSize.Medium
                            textStyle.fontWeight: FontWeight.W100
                            horizontalAlignment: HorizontalAlignment.Center
                            //verticalAlignment: VerticalAlignment.Center
                            textStyle.color: Color.create("#ffffffff")
                            onCreationCompleted: {
                                if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
                                    textStyle.color = Color.create("#ffe4e4e4")

                                } else {
                                    textStyle.color = Color.create("#ff202020")
                                }
                            }
                        }
                    }
                }

            }

        }

        Container {

            id: title_

            horizontalAlignment: HorizontalAlignment.Fill
            //verticalAlignment: VerticalAlignment.Bottom
            bottomPadding: 10
            layout: DockLayout {
            }
            /*Divider {
             * horizontalAlignment: HorizontalAlignment.Fill
             * verticalAlignment: VerticalAlignment.Fill
             * }*/
            Container {
                background: getDividerColor()
                preferredHeight: 1
                preferredWidth: Infinity
                topPadding: 0
                bottomPadding: 0
                topMargin: 0
                bottomMargin: 0
                function getDividerColor() {
                    if (themeStyleToString(Application.themeSupport.theme.colorTheme.style) == "bright") {
                        return Color.DarkGray;

                    } else {
                        return Color.DarkGray;
                    }
                }
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                leftPadding: 3
            	rightPadding: 3
                Label {
                    objectName: "titleLabel"
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Bottom
                    multiline: true
                    text: "Loading posts..."
                    textStyle.fontSize: FontSize.Medium
                    textStyle.fontWeight: FontWeight.W100
                    textStyle.textAlign: TextAlign.Center
                    autoSize.maxLineCount: 4
                    //textStyle.lineHeight: 0.9
                }
            }
        }
    }

}
