import bb.cascades 1.0
import Network.MessagesHttp 1.0
import bb.system 1.0
import Network.PostActions 1.0

Page {
    //property variant dataObject
    property string likes
    property string body
    property string author
    property string votes
    property string subject
    property string name
    property variant downVoteColor: Color.create("#6F72FB")
    property variant upVoteColor: Color.create("#F96E3B")
    signal back()
    id: commentReplyView
    titleBar: TitleBar {
        title: subject //"Reply to Comment"
        dismissAction: ActionItem {
            title: "Cancel"
            onTriggered: {
                // Cancel has been pressed so we emit the cancel signal (will hide the sheet).
                commentReplyView.back();
            }
        }
        acceptAction: ActionItem {
            title: "Submit"
            id: acceptAction
            enabled: false
            onTriggered: {
                //acceptAction.setEnabled(false);
                postActions.editPost(replyTextArea.text, name);
                commentReplyView.back();
                //activity.start();
            }
        }
        attachedObjects: [
            PostActions {
                id: postActions
            }
        ]
    }
    Container {
        verticalAlignment: VerticalAlignment.Fill
        layout: DockLayout {

        }
        ScrollView {
            Container {
                Container {
                    layout: StackLayout {
                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    Container {
                        preferredWidth: Infinity
                        background: Color.create("#CEE3F8")
                        Container {
                            id: labelsContainer
                            leftPadding: 10
                            rightPadding: 10
                            Container {
                                layout: StackLayout {
                                    orientation: LayoutOrientation.LeftToRight
                                }
                                Label {
                                    id: scoreLabel
                                    text: votes
                                    textStyle.fontSize: FontSize.Medium
                                    textStyle.color: Color.Black //getVote()
                                    rightMargin: 10
                                    function getVote() {
                                        if (likes == true) {
                                            return upVoteColor;
                                        } else if (likes == false) {
                                            return downVoteColor;
                                        } else {
                                            return Color.Black
                                        }
                                    }
                                }
                                Label {
                                    id: authorLabel
                                    text: "by " + author
                                    textStyle.fontSize: FontSize.Medium
                                    textStyle.color: Color.DarkGray
                                    touchPropagationMode: TouchPropagationMode.PassThrough
                                }
                            }
                        }
                    }
                    Divider {
                    }
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        leftPadding: 10
                        rightPadding: 10
                        TextArea {
                            id: replyTextArea
                            text: body
                            minHeight: 200
                            onTextChanging: {
                                acceptAction.setEnabled(true);
                            }
                        }

                    }
                }
            }
        }
        ActivityIndicator {
            id: activity
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Center
            preferredWidth: 200
            preferredHeight: 200
        }
    }
    onLikesChanged: {
        if (likes == "true") {
            scoreLabel.textStyle.color = upVoteColor;
        } else if (likes == "false") {
            scoreLabel.textStyle.color = downVoteColor;
        } else {
            scoreLabel.textStyle.color = Color.Black
        }
    }
}