import bb.cascades 1.2
import Network.FeedHttpCalls 1.0
import org.labsquare 1.0
import "markdown2html.js" as MarkdownConverter

Page {
    id: infoView
    property string subUrl
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.HideOnScroll
    titleBar: TitleBar {
        title: "Sidebar"
    }
    Container {
        layout: DockLayout {
        }
        ScrollView {
            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                background: Color.create("#CEE3F8")
                
                Container {
                    background: Color.create("#EFF7FF")
                    preferredWidth: Infinity
                    topPadding: 15
                    bottomPadding: 15
                    leftPadding: 15
                    rightPadding: 15
                    Label {
                        id: titleLabel
                        textStyle.fontWeight: FontWeight.Bold
                        textStyle.fontSize: FontSize.XXLarge
                        textStyle.color: Color.Black
                    }
                    Label {
                        id: subscriberLabel
                        textStyle.color: Color.Black
                        textStyle.fontSize: FontSize.Large
                        bottomMargin: 0
                        bottomPadding: 0
                    }
                    Label {
                        topMargin: 0
                        topPadding: 0
                        id: accountsActiveLabel
                        textStyle.color: Color.Black
                        textStyle.fontSize: FontSize.Large
                    }
                    WebImageView {
                        id: headerImage

                        objectName: "thumbnailImage"
                        //imageSource: "asset:///images/gold-insignia-big.png"
                        horizontalAlignment: HorizontalAlignment.Left
                        verticalAlignment: VerticalAlignment.Center
                        scalingMethod: ScalingMethod.AspectFit
                    }
                }
                Container {
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    topPadding: 15
                    bottomPadding: 15
                    leftPadding: 15
                    rightPadding: 15
                    Label {
                        id: descriptionLabel
                        objectName: "descriptionLabel"
                        //text: checkSelftext()
                        multiline: true
                        textStyle.color: Color.Black
                        content.flags: TextContentFlag.ActiveText
                        activeTextHandler: ActiveTextHandler {
                            id: activeTextHandler
                            onTriggered: {
                                var getOpenLinksBrowser = Qt.app.getSavedValue("openLinksBrowser", "");
                                if (getOpenLinksBrowser != "true") {
                                    event.abort();
                                    if ((event.text).indexOf("www.reddit.") != -1) {
                                        Qt.app.invokeMyself(event.text);
                                    } else {
                                        openWebview(event.text);
                                    }
                                }
                            }
                            function openWebview(pUrl) {
                                var page = Qt.webView.createObject();
                                page.webUrl = pUrl;
                                page.pageTitle = ""
                                infoView.parent.push(page);
                            }
                        }
                        /*function checkSelftext() {
                         * if (ListItemData.data.selftext != "") {
                         * var formattedText = MarkdownConverter._RunSpanGamut(ListItemData.data.selftext);
                         * return "<html>" + formattedText + "</html>";
                         * } else {
                         * leadingInfoLabel.setVisible(false);
                         * return "";
                         * }
                         }*/
                    }
                }
            }
        }
        ActivityIndicator {
            objectName: "indicator"
            id: activity
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Center
            preferredWidth: 200
            preferredHeight: 200
        }
    }
    attachedObjects: [
        FeedHttpCalls {
            id: feedHttp
            onSubredditInfoRetrieved: {
                titleLabel.text = display_name;
                headerImage.setUrl(header_img);
                var formattedText = MarkdownConverter._RunSpanGamut(description_html);
                descriptionLabel.setText("<html>" + formattedText + "</html>");
                subscriberLabel.setText(subscribers + " readers");
                accountsActiveLabel.setText(accounts_active + " users here now");
            }
        }
    ]
    onSubUrlChanged: {
        console.log(subUrl);
        feedHttp.getSubredditInfo(subUrl, activity);
    }
}
