import bb.cascades 1.0
import Network.MessagesHttp 1.0
import bb.system 1.0

Page {
    property string subject
    property variant dataObject
    property string parentID
    id: messageDetailsView
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.HideOnScroll
    actionBarVisibility: ChromeVisibility.Overlay
    titleBar: TitleBar {
        id: titleBar
        title: subject
    }
    Container {
        layout: DockLayout {

        }
        ScrollView {
            Container {
                Container {
                    layout: StackLayout {
                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    Container {
                        horizontalAlignment: HorizontalAlignment.Fill
                        background: Color.create("#CEE3F8")
                        Container {
                            id: labelsContainer
                            leftPadding: 10
                            rightPadding: 10
                            Label {
                                id: bodyLabel
                                textStyle.fontSize: FontSize.Medium
                                textStyle.color: Color.Black
                                multiline: true
                                content.flags: TextContentFlag.ActiveText
                            }
                            Label {
                                id: senderLabel
                                textStyle.fontSize: FontSize.Medium
                                textStyle.color: Color.DarkGray
                            }
                        }
                    }
                    Divider {
                    }
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        leftPadding: 10
                        rightPadding: 10
                        TextArea {
                            id: replyTextArea
                            hintText: "reply..."
                            minHeight: 200
                        }
                        Button {
                            id: replySubmitButton
                            horizontalAlignment: HorizontalAlignment.Center
                            text: "submit"
                            preferredWidth: 300
                            onClicked: {
                                activity.start();
                                replySubmitButton.setEnabled(false);
                                //var replyId = dataObject.data.name;
                                messagesHttp.replyMessage(replyTextArea.text, dataObject.data.name);
                            }
                        }
                        attachedObjects: [
                            MessagesHttp {
                                id: messagesHttp
                                onReplySent: {
                                    if (success == true) {
                                        //replySentToast.body = "Reply sent successfully!";
                                        replyTextArea.resetText();
                                    } else {
                                        //replySentToast.body = "Error sending reply, try again later!";
                                    }
                                    activity.stop();
                                    replySubmitButton.setEnabled(true);
                                    //replySentToast.show();
                                }
                            }
                        ]
                    }
                }
            }
        }
        ActivityIndicator {
            id: activity
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Center
            preferredWidth: 200
            preferredHeight: 200
        }
    }
    onDataObjectChanged: {
        bodyLabel.setText(getTitle());
        senderLabel.setText(getFromText());
        if (Qt.messagesType == "inbox") {
            replyTextArea.visible = true;
            replySubmitButton.visible = true;
        } else {
            replyTextArea.visible = false;
            replySubmitButton.visible = false;
        }
    }
    function getTitle() {
        var titleValue;
        if (dataObject.data.title == null) {
            titleValue = dataObject.data.body;
        } else {
            titleValue = dataObject.data.title;
        }
        return titleValue;
    }
    function getFromText() {
        var subString;
        if (dataObject.kind == "t1") {
            subString = "from " + dataObject.data.author + " via " + dataObject.data.subreddit;
        } else if (dataObject.kind == "t4") {
            subString = "from " + dataObject.data.author;
        }
        return subString;
    }
}