var g_urls;
var g_titles;
var g_html_blocks;

function _RunSpanGamut(text) {
	g_urls = new Array();
	g_titles = new Array();
	g_html_blocks = new Array();
	//text = _DoCodeSpans(text);
	//text = _EscapeSpecialCharsWithinTagAttributes(text);
	//text = _EncodeBackslashEscapes(text);
	// Process anchor and image tags. Images must come first,
	// because ![foo][f] looks like an anchor.
	//text = _DoImages(text);
	text = _DoAnchors(text);
	// Make links out of things like `<http://example.com/>`
	// Must come after _DoAnchors(), because you can use < and >
	// delimiters in inline links like [this](<url>).
	//text = _DoAutoLinks(text);
	//text = _EncodeAmpsAndAngles(text);
	text = _DoItalicsAndBold(text);
	// Do hard breaks:
	text = text.replace(/  +\n/g, " \n");
	return text;
}

function _DoAnchors(text) {
	text = text.replace(
			/(\[((?:\[[^\]]*\]|[^\[\]])*)\][ ]?(?:\n[ ]*)?\[(.*?)\])()()()()/g,
			writeAnchorTag);
	text = text
			.replace(
					/(\[((?:\[[^\]]*\]|[^\[\]])*)\]\([ \t]*()<?((?:\([^)]*\)|[^()])*?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g,
					writeAnchorTag);
	text = text.replace(/(\[([^\[\]]+)\])()()()()()/g, writeAnchorTag);
	return text;
}

function writeAnchorTag(wholeMatch, m1, m2, m3, m4, m5, m6, m7) {
	if (m7 == undefined)
		m7 = "";
	var whole_match = m1;
	var link_text = m2;
	var link_id = m3.toLowerCase();
	var url = m4;
	var title = m7;
	if (url == "") {
		if (link_id == "") {
			// lower-case and turn embedded newlines into spaces
			link_id = link_text.toLowerCase().replace(/ ?\n/g, " ");
		}
		url = "#" + link_id;
		if (g_urls[link_id] != undefined) {
			url = g_urls[link_id];
			if (g_titles[link_id] != undefined) {
				title = g_titles[link_id];
			}
		} else {
			if (whole_match.search(/\(\s*\)$/m) > -1) {
				// Special case for explicit empty url
				url = "";
			} else {
				return whole_match;
			}
		}
	}
	url = encodeProblemUrlChars(url);
	//url = escapeCharacters(url, "*_");
	var result = "<a href=\"" + url + "\"";
	if (title != "") {
		title = title.replace(/"/g, "&quot;");
		title = escapeCharacters(title, "*_");
		result += " title=\"" + title + "\"";
	}
	result += ">" + link_text + "</a>";
	return result;
}
function encodeProblemUrlChars(url) {
	var _problemUrlChars = /(?:["'*()[\]:]|~D)/g;
	if (!url)
		return "";
	var len = url.length;
	return url.replace(_problemUrlChars, function(match, offset) {
		if (match == "~D") // escape for dollar
			return "%24";
		if (match == ":") {
			if (offset == len - 1 || /[0-9\/]/.test(url.charAt(offset + 1)))
				return ":";
		}
		return "%" + match.charCodeAt(0).toString(16);
	});
}
function escapeCharacters(text, charsToEscape, afterBackslash) {
	var regexString = "([" + charsToEscape.replace(/([\[\]\\])/g, "\\$1")
			+ "])";
	if (afterBackslash) {
		regexString = "\\\\" + regexString;
	}
	var regex = new RegExp(regexString, "g");
	text = text.replace(regex, escapeCharacters_callback);
	return text;
}
function escapeCharacters_callback(wholeMatch, m1) {

	var charCodeToEscape = m1.charCodeAt(0);

	return "~E" + charCodeToEscape + "E";

}

function _DoItalicsAndBold(text) {
	// <strong> must go first:
	text = text.replace(
			/([\W_]|^)(\*\*|__)(?=\S)([^\r]*?\S[\*_]*)\2([\W_]|$)/g,

			"$1<strong>$3</strong>$4");
	text = text.replace(/([\W_]|^)(\*|_)(?=\S)([^\r\*_]*?\S)\2([\W_]|$)/g,
			"$1<em>$3</em>$4");
	return text;

}
